#include <stdio.h>
#include <string.h>
typedef struct
{
  char d[501];
  int n;
} number_t;

typedef enum {op_add, op_sub, op_mul} op_t;

number_t x,y,res,pres[501]; /* data x, data y, result, partial result (mul) */
op_t op;

void swap_digits(number_t *n)
{
  int i,j;
  char t;
  for (i=0, j=n->n-1; i<j; i++,j--)
    {
      t=n->d[i];
      n->d[i]=n->d[j];
      n->d[j]=t;
    }
}
void read_expr()
{
  char line[1024];
  char *p;

  fgets(line,1024,stdin);
  p=line;
  /* read first number */
  x.n=0;
  while (strchr("0123456789",*p))
    {
      x.d[x.n++]=*p-'0';
      p++;
    }
  /* read operator */
  switch (*p)
    {
    case '+':
      op=op_add;
      break;
    case '-':
      op=op_sub;
      break;
    case '*':
      op=op_mul;
      break;
    }
  p++;
  /* read second number */
  y.n=0;
  while (strchr("0123456789",*p))
    {
      y.d[y.n++]=*p-'0';
      p++;
    }
  swap_digits(&x);
  swap_digits(&y);
}

void add()
{
  int i;
  char c=0;
  for (i=0; i<x.n && i<y.n; i++)
    {
      res.d[i]=x.d[i]+y.d[i]+c;
      if (res.d[i]>9)
	{
	  c=1;
	  res.d[i]-=10;
	}
      else
	c=0;
    }
  while (i<x.n)
    {
      res.d[i]=x.d[i]+c;
      if (res.d[i]>9)
	{
	  c=1;
	  res.d[i]-=10;
	}
      else
	c=0;
      i++;
    }
  while (i<y.n)
    {
      res.d[i]=y.d[i]+c;
      if (res.d[i]>9)
	{
	  c=1;
	  res.d[i]-=10;
	}
      else
	c=0;
      i++;
    }
  if (c>0) 
    res.d[i++]=c;
  res.n=i;
}

void sub()
{
  int i;
  char c=0;
  for(i=0; i<y.n; i++)
    {
      res.d[i]=x.d[i]-y.d[i]-c;
      if (res.d[i]<0)
	{
	  c=1;
	  res.d[i]+=10;
	}
      else
	c=0;
    }
  while (i<x.n)
    {
      res.d[i]=x.d[i]-c;
      if (res.d[i]<0)
	{
	  c=1;
	  res.d[i]+=10;
	}
      else
	c=0;
      i++;
    }
  while (res.d[i-1]==0)
    i--;
  res.n=i;
}

void add_with_shift(int s)
{
  int i;
  char c=0;
  
  for (i=s; i<res.n && i<(pres[s].n+s); i++)
    {
      res.d[i]=res.d[i]+pres[s].d[i-s]+c;
      if (res.d[i]>9)
	{
	  c=1;
	  res.d[i]-=10;
	}
      else
	c=0;
    }
  while (i<res.n)
    {
      res.d[i]=res.d[i]+c;
      if (res.d[i]>9)
	{
	  c=1;
	  res.d[i]-=10;
	}
      else
	c=0;
      i++;
    }
  while (i<(pres[s].n+s))
    {
      res.d[i]=pres[s].d[i-s]+c;
      if (res.d[i]>9)
	{
	  c=1;
	  res.d[i]-=10;
	}
      else
	c=0;
      i++;
    }
  if (c>0) 
    res.d[i++]=c;
  res.n=i;
}

void mul_by_digit(int i)
{
  int j;
  char c=0;
  char d=y.d[i];
  if (d==0) 
    {
      pres[i].n=1;
      pres[i].d[0]=0;
      return;
    }
  for (j=0; j<x.n; j++)
    {
      pres[i].d[j]=x.d[j]*d+c;
      if (pres[i].d[j]>9)
	{
	  c=pres[i].d[j]/10;
	  pres[i].d[j]%=10;
	}
      else
	c=0;
    }
  if (c>0)
    pres[i].d[j++]=c;
  pres[i].n=j;
}

void mul()
{
  int i;
  for (i=0; i<y.n; i++)
    mul_by_digit(i);
  res=pres[0];
  for (i=1; i<y.n; i++)
    add_with_shift(i);
  while (res.n>1 && res.d[res.n-1]==0)
    res.n--;
}

void show_number(number_t *n)
{
  int i;
  for (i=n->n-1; i>=0; i--)
    fputc(n->d[i]+'0',stdout);
}

void show_simple()
{
  int r,r2,i;
  r=x.n;
  if (y.n+1>r)
    r=y.n+1;
  if (res.n>r)
    r=res.n;
  
  r2=y.n+1;
  if (res.n>r2)
    r2=res.n;
  
  for (i=0; i<r-x.n; i++)
    printf(" ");
  show_number(&x);
  printf("\n");
  for (i=0; i<r-y.n-1; i++)
    printf(" ");
  printf("%c",(op==op_add)?'+':'-');
  show_number(&y);
  printf("\n");
  for (i=0; i<r-r2; i++)
    printf(" ");
  for (i=r-r2; i<r; i++)
    printf("-");
  printf("\n");
  for (i=0; i<r-res.n; i++)
    printf(" ");
  show_number(&res);
  printf("\n\n");
}

void show_mul()
{
  int r1,r2,r3,i,j;
  r1=0;
  if (y.n+1>r1)
    r1=y.n+1;
  if (pres[0].n>r1)
    r1=pres[0].n;
  r2=r1;
  if (x.n>r2)
    r2=x.n;
  if (res.n>r2)
    r2=res.n;
  r3=pres[y.n-1].n+y.n-1;
  if (res.n>r3)
    r3=res.n;

  for (i=0; i<r2-x.n; i++)
    printf(" ");
  show_number(&x);
  printf("\n");
  for (i=0; i<r2-y.n-1; i++)
    printf(" ");
  printf("*");
  show_number(&y);
  printf("\n");
  for (i=0; i<r2-r1; i++)
    printf(" ");
  for (i=r2-r1; i<r2; i++)
    printf("-");
  printf("\n");
  for (i=0; i<r2-pres[0].n; i++)
    printf(" ");
  show_number(&pres[0]); 
  putc('\n',stdout);
 
  if (y.n>1)
    {
      for (i=1; i<y.n; i++)
	{
	  for (j=0; j<r2-pres[i].n-i; j++)
	    printf(" ");
	  show_number(&pres[i]);
	  printf("\n");
	}
      for (i=0; i<r2-r3; i++)
	printf(" ");
      for (i=r2-r3; i<r2; i++)
	printf("-");
      printf("\n");
      for (i=0; i<r2-res.n; i++)
	printf(" ");
      show_number(&res);
      putc('\n',stdout);
    }
  putc('\n',stdout);

}

void solve()
{
  switch (op)
    {
    case op_add:
      add();
      show_simple();
      break;
    case op_sub:
      sub();
      show_simple();
      break;
    case op_mul:
      mul();
      show_mul();
      break;
    }
}

int main()
{
  int t;
  scanf("%d\n",&t);
  while (t>0)
    {
      read_expr();
      solve();
      t--;
    }
  return 0;
}




