#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define NP 110

int primes[ NP ], values[ 200 ], T, S, C;
int rescalers[ 100 ][ NP ];

void do_primes( );
void primify( int [ NP ], int );
int intify( int [ NP ] );
void divide( int [ NP ], int [ NP ] );
void multiply( int [ NP ], int [ NP ] );
void subpoly( int, int, int [ NP ] );
void do_rescalers( );
void solve( );
int do_value( int );

int main( )
{

  int i;
  
    do_primes( );

    scanf( "%d\n", & T );
    
    while( T-- ) {
    
        scanf( "%d %d\n", & S, & C );
        
        for( i = 0; i < S; i++ )
            scanf( "%d ", values + i );
            
        solve( );
            
    }

    return 0;

}

void do_primes( )
{

  int i, j;
  
    for( i = 0; i < NP; i++ )
        primes[ i ] = 1;
  
    for( i = 2; i < NP; i++ )
        if( ! primes[ i ] ) continue;
        else for( j = i * 2; j < NP; j += i ) primes[ j ] = 0;

}

void primify( int p[ NP ], int n )
{

  int i = 2;
  
    memset( p, 0, NP * sizeof( int ) );
    
    while( n > 1 )    
        if( n % i ) while( ! primes[ ++i ] ) ;
        else { ++p[ i ]; n /= i; };

}

int intify( int t[ NP ] )
{

  int r = 1, i;
  
    for( i = i; i < NP; i++ )
        while( t[ i ]-- ) r *= i;
        
    return r;

}

void divide( int n1[ NP ], int n2[ NP ] )
{

  int i;
  
    for( i = 0; i < NP; i++ )
        n1[ i ] -= n2[ i ];

}

void multiply( int n1[ NP ], int n2[ NP ] )
{

  int i;
  
    for( i = 0; i < NP; i++ )
        n1[ i ] += n2[ i ];

}

void subpoly( int which, int where, int r[ NP ] )
{

  int i, tmp[ NP ];
  
    for( i = 1; i <= S; i++ ) {
    
        if( i == which ) continue;
        
        primify( tmp, where - i );
        multiply( r, tmp );
        
    }

}

void do_rescalers( )
{

  int i;

    for( i = 1; i <= S; i++ )
        subpoly( i, i, rescalers[ i ] ); 

}

void solve( )
{

  int i;

    do_rescalers( );
    
    for( i = S + 1; i <= C + S; i++ )
        printf( "%d ", do_value( i ) );
        
    printf( "\b\n" );     

}

int do_value( int where )
{

  int t1[ NP ], t2[ NP ], r = 0, i;
    
    for( i = 1; i <= S; i++ ) {
    
        memset( t1, 0, sizeof( int ) * NP );
        subpoly( i, where, t1 );
        primify( t2, values[ i ] );
        multiply( t1, t2 );
        divide( t1, rescalers[ i ] );
        r += intify( t1 );
    
    }
    
    return r;

}
