#include <stdio.h>
#include <stdlib.h>


#define MAXILLETTERS 90 // max. number of letters abcdef...
#define MAXILKEYS 90 // max. number of keys 2 3 4 5 6 ...

int K, // number of keys
  L; // number of letters
char keys[MAXILKEYS+10];
char letters[MAXILLETTERS+10];
int letterFreq[MAXILLETTERS+10];
int whichKey[MAXILLETTERS+10]; // do ktorego klawisza przyp. i-ta litera

void obetnijrn(char * b)
{
  int dl = strlen(b);
  while ((dl>0) && ((b[dl-1]=='\r') || (b[dl-1]=='\n'))) dl--;
  b[dl]=0;
}

struct Item
{
  int cost; // -1 => pole nie zapelnione
  int nr; // numer litery na klawiszu
  int x,y; // pozycja klawisza z prawej / z prawej-ukos
  int sumThisKlaw; // koszt liter z tego przycisku.(dla left) NowyKoszt=stary_koszt+sumThisKlaw+ta_litera. nowy_sumThisKlaw = sumThisKlaw+ta_litera.
  Item() : cost(-1), nr(0), x(0), y(0), sumThisKlaw(0)
  {
  }
  Item(int c, int n, int x, int y, int s)
    : cost(c), nr(n), x(x), y(y), sumThisKlaw(s)
  {
  }
};

// x-letter, y-key
//#define tabb(x,y) items[(y)*(L+1)+(x)]

Item * items;

Item & tabb(int x,int y)
{
  return items[(y)*(L+1)+(x)];
}

void dynam()
{
  items = new Item[(K+1)*(L+1)];
  tabb(L-1, K-1) = Item(letterFreq[L-1], 0, -1, -1, letterFreq[L-1]);
  for (int lkey =K-1;lkey>=0;--lkey)
    {
      for (int llet=L-1;llet>0;--llet)
	{
	  Item & ten = tabb(llet, lkey);
	  if (ten.cost==-1)
	    continue;
	  {
	    // klawisz z lewej (ten sam klawisz, inna litera)
	    Item & left = tabb(llet-1, lkey);
	    Item nowyLeft = Item(ten.cost + ten.sumThisKlaw + letterFreq[llet-1], 
				 ten.nr+1,
				 llet, lkey,
				 ten.sumThisKlaw + letterFreq[llet-1]
				 );
	    if ((left.cost==-1) || (left.cost > nowyLeft.cost))
	      left = nowyLeft;
	    else
	      // tam juz jest to samo-lepiej bedzie, jezeli bedzie z ukosa, a nie
	      // z tego samego poziomu (wtedy poprzedni klawisz bedzie
	      // mial wiecej liter)
	      {
		if (nowyLeft.cost == left.cost)
		  {
		    // nie ro update
		    (void)0;
		  }
	      }
	  }
	  
	  // klawisz z lewa-gora (poprzedni klawisz)
	  if (lkey>0)
	  {
	    Item & leftUp = tabb(llet-1, lkey-1);
	    Item nowyLeftUp = Item(ten.cost +
				   letterFreq[llet-1], 
				   0,
				   llet, lkey,
				   letterFreq[llet-1]
				   );
	    if ((leftUp.cost==-1) || (leftUp.cost > nowyLeftUp.cost))
	      leftUp = nowyLeftUp;
	    else
	      // tam juz jest to samo-lepiej bedzie, jezeli bedzie z ukosa, a nie
	      // z tego samego poziomu (wtedy poprzedni klawisz bedzie
	      // mial wiecej liter)
	      {
		if (nowyLeftUp.cost == leftUp.cost)
		  {
		    leftUp = nowyLeftUp;
		  }
	      }
	  }
	  
	}
    }
  // przepisz wyniki do whichKey
  if (tabb(0,0).cost==-1)
    {
      fprintf(stderr, "nie doszlo do konca !!!");
    }
  int pozx = 0, // letter
    pozy = 0; // key
  for (int i=0;i<L;++i)
    {
      whichKey[pozx] = pozy;
      if (i!=pozx)
	{
	  printf("Zle obliczenia, pozx=%d, i=%d\n", pozx, i);
	} 
      Item & ten = tabb(pozx, pozy);
      pozx = ten.x;
      pozy = ten.y;
    }
  delete[] items;
}

void licz(int nr)
{
  scanf("%d %d\n", &K, &L);
  fgets(keys, MAXILKEYS+5, stdin);
  fgets(letters, MAXILLETTERS+5, stdin);
  obetnijrn(keys);
  obetnijrn(letters);
  char linia[100];
  for (int i=0;i<L;++i)
    {
      fgets(linia, 90, stdin);
      obetnijrn(linia);
      letterFreq[i] = atoi(linia);
    }
  dynam();
  printf("Keypad #%d\n", nr);
  int nlet = 0;
  for (int i=0;i<K;++i)
    {
      printf("%c: ", keys[i]);
      while ((whichKey[nlet]==i) && (nlet<L))
	{
	  fputc(letters[nlet], stdout);
	  nlet++;
	}
      fputc('\n', stdout);
    }
  fputc('\n', stdout);
}

int main()
{
  int N;
  scanf("%d",&N);
  for (int i=0;i<N;++i)
    {
      licz(i+1);
    }
  return 0;
}

